@isTest
private class TestSalesIQDataTableCtrl {



    static {
        TriggerContol__c triggerSecurityUtil = new TriggerContol__c (IsStopTrigger__c = true , Name='SecurityUtil');
        insert triggerSecurityUtil;
        TriggerContol__c triggerScenario = new TriggerContol__c (IsStopTrigger__c = true , Name='ScenarioTrigger');
        insert triggerScenario;
    }
     static testMethod void testEmployeeDataTable() {

        Employee__c emp = CallPlanTestDataFactory.createEmployee();
         insert emp;
         Team__c team = CallPlanTestDataFactory.createTeam('Base');
         insert team;
         Team_Instance__c team_instance = CallPlanTestDataFactory.CreateTeamInstance(team,'Zip');
         insert team_instance;
         Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
         insert pos;

         SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
         generator.s = 'true';
         generator.objectName = 'Employee__c';
         Test.setMock(HttpCalloutMock.class, generator);

        
         test.startTest();
         SalesIQDataTableCtrl.getOrgNamespace();
         SalesIQDataTableCtrl.getCustomSettingforDisclaimer();
        map<String,list<String>> profileMap = SalesIQDataTableCtrl_V2.getProfileNameMap();
        SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Employee__c', '','','','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'', JSON.serialize(profileMap),'');
        String first = SalesIQDataTableCtrl.getFirstListView('Employee__c');
        SalesIQDataTableWrapper wrap2 = SalesIQDataTableCtrl.getRecentData('Employee__c','','','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        SalesIQDataTableWrapper wrap3 = SalesIQDataTableCtrl.getNextData('Employee__c',1,wrap.queryString,wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        SalesIQDataTableWrapper wrap4 = SalesIQDataTableCtrl.getSortData('Employee__c','Name','ASC',wrap.queryString,wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        SalesIQDataTableWrapper wrap5 = SalesIQDataTableCtrl.getSearchData('Employee__c','',wrap.queryString,'',wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        SalesIQDataTableWrapper wrap6 = SalesIQDataTableCtrl.getExport('Employee__c',wrap.queryString,wrap.columnsList,wrap.dataTypesList,SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE);

        
         test.stopTest();
     }

     static testMethod void getErrors() {

        Employee__c emp = CallPlanTestDataFactory.createEmployee();
         insert emp;
         Team__c team = CallPlanTestDataFactory.createTeam('Base');
         insert team;
         Team_Instance__c team_instance = CallPlanTestDataFactory.CreateTeamInstance(team,'Zip');
         insert team_instance;
         Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
         insert pos;

         SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
         generator.s = 'true';
         generator.objectName = 'Employee__c';
         Test.setMock(HttpCalloutMock.class, generator);

        
         test.startTest();
         SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Employee__c','','','','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'', '','');
        
        try{
        SalesIQDataTableWrapper wrap7 = SalesIQDataTableCtrl.getData('','Position__c', '','','','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'', '','');
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        SalesIQDataTableWrapper wrap2 = SalesIQDataTableCtrl.getRecentData('','','','',SalesIQGlobalConstants.POSITION_UNIVERSE,'','');
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        SalesIQDataTableWrapper wrap3 = SalesIQDataTableCtrl.getNextData('Employee__c',1,'error',new List<String>{'Position_Type__c'},wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        // SalesIQDataTableWrapper wrap4 = SalesIQDataTableCtrl.getSortData('Employee__c','Name','ASC',wrap.queryString,wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'');
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        SalesIQDataTableWrapper wrap5 = SalesIQDataTableCtrl.getSearchData('Employee__c','','select','',wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        SalesIQDataTableWrapper wrap6 = SalesIQDataTableCtrl.getExport('Employee__c','sadas',wrap.columnsList,wrap.dataTypesList,SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE);
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        SalesIQDataTableWrapper wrap8 = SalesIQDataTableCtrl.getSortData('Employee__c','Name','ASC','errorString',wrap.columnsList,wrap.dataTypesList,'','',SalesIQGlobalConstants.EMPLOYEE_UNIVERSE,'','');
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }
        try{
        List<String> disabledCheckbox = SalesIQDataTableCtrl.getDisabledCheckboxList('Employee__c','inactive__c = true');
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
        }

        
         test.stopTest();
     }

     static testMethod void testWorkspaceDataTable() {
        try{
            TriggerContol__c triggerControlPosition = new TriggerContol__c (IsStopTrigger__c = true , Name='PositionTrigger');
            insert triggerControlPosition;

            Interface_Style_Config__c interfacestyle = new Interface_Style_Config__c();
            interfacestyle.IsEnabled__c = true;
            interfacestyle.Name = 'abc';
            interfacestyle.Field_Name__c = 'Name';
            interfacestyle.Field_Value__c = 'Scenario-001';
            interfacestyle.Interface_Name__c = 'Scenario__c';

            Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
            insert org;
            Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
            insert country;
            Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
            insert geotype;
            
            insert interfacestyle;

            Workspace__c workspace1 = new Workspace__c();
            workspace1.Name = 'test1';
            workspace1.Workspace_Description__c = 'Description';
            workspace1.Workspace_Start_Date__c = date.today();
            workspace1.Workspace_End_Date__c = date.today() + 5;
            workspace1.Country__c = country.id;
            insert workspace1;

            Workspace__c work = [Select id from Workspace__c limit 1];

            Scenario__c s = new Scenario__c();
            s.Workspace__c = work.Id;
            insert s;
        
            Team__c team = TestDataFactory.createTeam('Base');
            insert team;

            Team_Instance__c team_instance = TestDataFactory.CreateTeamInstance(team.Id,'Zip','',Date.today()-100,Date.today()+100);
            insert team_instance; 
            Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
            pos.Hierarchy_Level__c = '2';
            pos.Team_Instance__c = team_instance.Id;
            pos.Position_Type__c = 'District';
            insert pos;
            
            Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
            User usr = TestDataFactory.createUser(p.Id);
            insert usr;
            System.runAs(usr)
             { 
                List<PermissionSet> ps = [SELECT Id, Name From PermissionSet];
            
                TestDataFactory.assignPermissionSet(usr.Id, 'SalesIQ_HO');
            
                User_Access_Permission__c objUserAccessPerm = TestDataFactory.createUserAccessPerm(pos.Id,usr.Id,team_instance.Id);
                insert objUserAccessPerm;
                SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
                generator.s = 'true';
                generator.objectName = 'Workspace__c';
                Test.setMock(HttpCalloutMock.class, generator);
                
                User_Persistence__c userPersistance = new User_Persistence__c();
                userPersistance.Workspace_Country__c = country.id;
                userPersistance.Default_Country__c = null;
                userPersistance.User__c = usr.Id;
                insert userPersistance;

                test.startTest();
                 
                SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Workspace__c','','','','','Workspace Universe',String.valueOf(country.id), '','');
                SalesIQDataTableCtrl.setCountryForUser(country.id);
                SalesIQDataTableCtrl.checkCountryAccess(country.id);
                SalesIQDataTableCtrl.getWorkspaceName(workspace1.id);

                Country__c country2 = new Country__c();
                country2.name ='UK';
                country2.Country_Code__c = 'UK';
                country2.Status__c = 'Active';
                country2.Parent_Organization__c = org.id;
                insert country2;

                
                try{
                    userPersistance.Workspace_Country__c = country2.id;
                    userPersistance.Default_Country__c = country2.id;
                    update userPersistance;
                }catch(Exception e){}
                
                userPersistance.User__c = null;
                userPersistance.Default_Country__c = null;
                update userPersistance;

            String test1 = SalesIQDataTableCtrl.deleteRecord(work.Id,'Workspace__c');
            try{
            String test2 = SalesIQDataTableCtrl.deleteRecord(work.Id,'Scenario__c');
            }catch(Exception e) {
                String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
                AuraHandledException ex = new AuraHandledException(message);
                ex.setMessage(message);
            }
            SalesIQDataTableCtrl.logException('hello','world');
            test.stopTest();
            }
        }
        catch(Exception ex){
            System.debug(ex);
        }
    }

    static testMethod void testScenarioDataTable() {

        TriggerContol__c triggerControlPosition = new TriggerContol__c (IsStopTrigger__c = true , Name='PositionTrigger');
        insert triggerControlPosition;

        Interface_Style_Config__c interfacestyle = new Interface_Style_Config__c();
        interfacestyle.IsEnabled__c = true;
        interfacestyle.Name = 'abc';
        interfacestyle.Field_Name__c = 'Name';
        interfacestyle.Field_Value__c = 'Scenario-001';
        interfacestyle.Interface_Name__c = 'Scenario__c';
        
        insert interfacestyle;

        Workspace__c workspace1 = new Workspace__c();
        workspace1.Name = 'test1';
        workspace1.Workspace_Description__c = 'Description';
        workspace1.Workspace_Start_Date__c = date.today();
        workspace1.Workspace_End_Date__c = date.today().addMonths(1);
        insert workspace1;

        Workspace__c work = [Select id from Workspace__c limit 1];

        Scenario__c s = new Scenario__c();
        s.Workspace__c = work.Id;
        insert s;
    
        //Team__c team = CallPlanTestDataFactory.createTeam('Base');
        //Team_Instance__c team_instance = CallPlanTestDataFactory.CreateTeamInstance(team,'Zip');
        //Position__C pos = CallPlanTestDataFactory.createPosition(null,team);

        Team__c team = TestDataFactory.createTeam('Base');
        insert team;

        Team_Instance__c team_instance = TestDataFactory.CreateTeamInstance(team.Id,'Zip','',Date.today()-100,Date.today()+100);
        insert team_instance; 
         Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
         pos.Hierarchy_Level__c = '2';
         pos.Team_Instance__c = team_instance.Id;
         pos.Position_Type__c = 'District';
         insert pos;
         Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
         User usr = TestDataFactory.createUser(p.Id);
         insert usr;
        System.runAs(usr)
         { 
            List<PermissionSet> ps = [SELECT Id, Name From PermissionSet];
        
            TestDataFactory.assignPermissionSet(usr.Id, 'SalesIQ_HO');
        
       
        //User_Access_Permission__c useracc = TestDataFactory.createUserAccessPermission(pos.Id,usr.Id,team_instance.Id);
            //insert useracc;


         TriggerContol__c tc = new TriggerContol__c();
         tc.Name = 'SecurityUtil';
         tc.IsStopTrigger__c = true ;
         insert tc;

         TriggerContol__c tc1 = new TriggerContol__c();
         tc1.Name = 'ScenarioTrigger';
         tc1.IsStopTrigger__c = true ;
         insert tc1;
        

         TestDataFactory.createUserAccessPermissionFuture(pos.Id,usr.Id,team_instance.Id,'SalesIQ_HO');
         /*PermissionSet ps = [SELECT Name From PermissionSet WHERE Name = 'SalesIQ_HO'];
         insert new PermissionSetAssignment(AssigneeId = usr.Id, PermissionSetId = ps.Id );*/
          User_Access_Permission__c objUserAccessPerm = TestDataFactory.createUserAccessPerm(pos.Id,usr.Id,team_instance.Id);
         insert objUserAccessPerm;

        SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
        generator.s = 'true';
        generator.objectName = 'Scenario__c';
        Test.setMock(HttpCalloutMock.class, generator);

        
        test.startTest();
        SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Scenario__c','','','','','','', '{"System Administrator" : ["System Administrator"]}','');
        String first = SalesIQDataTableCtrl.getFirstListView('Scenario__c');
        SalesIQDataTableWrapper wrap2 = SalesIQDataTableCtrl.getRecentData('Scenario__c','','','','','','');
        SalesIQDataTableWrapper wrap3 = SalesIQDataTableCtrl.getNextData('Scenario__c',1,wrap.queryString,wrap.columnsList,wrap.dataTypesList,'','','','','');
        SalesIQDataTableWrapper wrap4 = SalesIQDataTableCtrl.getSortData('Scenario__c','Name','ASC',wrap.queryString,wrap.columnsList,wrap.dataTypesList,'','','','','');
        SalesIQDataTableWrapper wrap5 = SalesIQDataTableCtrl.getSearchData('Scenario__c','',wrap.queryString,'',wrap.columnsList,wrap.dataTypesList,'','','','','');
        SalesIQDataTableWrapper wrap6 = SalesIQDataTableCtrl.getExport('Scenario__c',wrap.queryString,wrap.columnsList,wrap.dataTypesList,SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE);
        List<String> disabledCheckbox = SalesIQDataTableCtrl.getDisabledCheckboxList('Position__c','inactive__c = true');
        
        test.stopTest();
        }
    }

    static testMethod void testPositionDataTable() {

         Employee__c emp = CallPlanTestDataFactory.createEmployee();
         insert emp;
       
         Team__c team = TestDataFactory.createTeam('Base');
         insert team;

         Team__c team2 = TestDataFactory.createTeam('Overlay');
         team2.Controlling_Team__c = team.Id;
         insert team2;

         Team_Instance__c team_instance1 = TestDataFactory.CreateTeamInstance(team.Id,'Zip','',Date.today()-100,Date.today()+100);
         insert team_instance1;

         Team_Instance__c team_instance = TestDataFactory.CreateTeamInstance(team2.Id,'Zip','',Date.today()-100,Date.today()+100);
         insert team_instance;

         Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
         pos.Hierarchy_Level__c = '2';
         pos.Team_Instance__c = team_instance1.Id;
         pos.Position_Type__c = 'District';
         insert pos;
         Position__C pos1 = CallPlanTestDataFactory.createPosition(pos,team);
         pos1.Team_Instance__c = team_instance1.Id;
         pos1.Position_Type__c = 'Territory';
         pos1.Hierarchy_Level__c = '1';
         insert pos1;

         System.debug('pos1 - '+pos1);

         Position__C posoverlay = CallPlanTestDataFactory.createPosition(pos,team2);
         insert posoverlay;         
         Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
         User usr = TestDataFactory.createUser(p.Id);
         insert usr;
         System.runAs(usr)
         { 
            List<PermissionSet> ps = [SELECT Id, Name From PermissionSet];
        
            TestDataFactory.assignPermissionSet(usr.Id, 'SalesIQ_HO');
        
       
        //User_Access_Permission__c useracc = TestDataFactory.createUserAccessPermission(pos.Id,usr.Id,team_instance.Id);
            //insert useracc;


         TriggerContol__c tc = new TriggerContol__c();
         tc.Name = 'SecurityUtil';
         tc.IsStopTrigger__c = true ;
         insert tc;

         TriggerContol__c tc1 = new TriggerContol__c();
         tc1.Name = 'ScenarioTrigger';
         tc1.IsStopTrigger__c = true ;
         insert tc1;
        

         TestDataFactory.createUserAccessPermissionFuture(pos.Id,usr.Id,team_instance.Id,'SalesIQ_HO');
         /*PermissionSet ps = [SELECT Name From PermissionSet WHERE Name = 'SalesIQ_HO'];
         insert new PermissionSetAssignment(AssigneeId = usr.Id, PermissionSetId = ps.Id );*/
         User_Access_Permission__c objUserAccessPerm = TestDataFactory.createUserAccessPerm(pos.Id,usr.Id,team_instance.Id);
         insert objUserAccessPerm;
         User_Access_Permission__c objUserAccessPerm2 = TestDataFactory.createUserAccessPerm(pos1.Id,usr.Id,team_instance1.Id);
         insert objUserAccessPerm2;

         Interface_Style_Config__c interfacestyle = new Interface_Style_Config__c();
        interfacestyle.IsEnabled__c = true;
        interfacestyle.Name = 'abc';
        interfacestyle.Field_Name__c = 'Position_Type__c';
        interfacestyle.Field_Value__c = 'District';
        interfacestyle.Interface_Name__c = 'Position__c';
        
        insert interfacestyle;

        ReadOnlyApplication__c readOnly  = new ReadOnlyApplication__c();
        readOnly.RosterDeletePosition__c = true; 
        readOnly.RosterEditPosition__c = true;
        readOnly.RosterHierarchyChange__c = true;
        readOnly.RosterPositionAccess__c = true;
        readOnly.Roster_Position_Attributes__c  = true;
        insert readOnly;

        CR_Team_Instance_Config__c crTeamInstConf = new CR_Team_Instance_Config__c();
        crTeamInstConf.Configuration_Value__c = 'Territory';
        crTeamInstConf.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConf.Configuration_Name__c = '1';
        crTeamInstConf.Create__c = true;
        crTeamInstConf.Delete__c = true;
        crTeamInstConf.Edit__c = true;
        crTeamInstConf.Hierarchy_Change__c = true;
        crTeamInstConf.team_instance__c = team_instance1.id;
        
        CR_Team_Instance_Config__c crTeamInstConfDistrict = new CR_Team_Instance_Config__c();
        crTeamInstConfDistrict.Configuration_Value__c = 'District';
        crTeamInstConfDistrict.Configuration_Type__c = 'Hierarchy Configuration';
        crTeamInstConfDistrict.Configuration_Name__c = '2';
        crTeamInstConfDistrict.Create__c = true;
        crTeamInstConfDistrict.Delete__c = true;
        crTeamInstConfDistrict.Edit__c = true;
        crTeamInstConfDistrict.Hierarchy_Change__c = true;
        crTeamInstConfDistrict.team_instance__c = team_instance1.id;
       
        insert new CR_Team_Instance_Config__c[]{crTeamInstConf, crTeamInstConfDistrict} ;
        System.assert(crTeamInstConfDistrict.id != null);
        System.assert(crTeamInstConf.id != null);

        Team_Instance_Configuration__c teamInsConfTerr = new Team_Instance_Configuration__c();
        teamInsConfTerr.name = 'TerrConfig';
        teamInsConfTerr.Hierarchy_Level__c = '1';
        teamInsConfTerr.Pattern_Value__c = 'Terr{0000}';
        teamInsConfTerr.Position_Type__c = 'Territory';
        
        string teamID = team.id;
        if(teamId.length() > 15){
            teamID = teamID.left(15);
        }
        
        teamInsConfTerr.Team__c = teamID;
        teamInsConfTerr.Team_Instance__c = team_instance1.id;
        //insert teamInsConfTerr;
         
        Team_Instance_Configuration__c teamInsConfDistr = new Team_Instance_Configuration__c();
        //teamInsConf.Configuration_Type__c = 
        teamInsConfDistr.name = 'DistrictConfig';
        teamInsConfDistr.Hierarchy_Level__c = '2';
        teamInsConfDistr.Pattern_Value__c = 'Dist{0000}';
        teamInsConfDistr.Position_Type__c = 'District';
        teamInsConfDistr.Team__c = teamID;
        teamInsConfDistr.Team_Instance__c = team_instance1.id;
        //insert teamInsConfDistr;

        insert new Team_Instance_Configuration__c[]{teamInsConfTerr, teamInsConfDistr};
        

          
         test.startTest();
         
         SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
         generator.s = 'true';
         generator.objectName = 'Position__c';
         Test.setMock(HttpCalloutMock.class, generator);
         SalesIQDataTableWrapper wrap = new SalesIQDataTableWrapper();
         try{
             wrap = SalesIQDataTableCtrl.getData('','Position__c', '',pos.Id,team_instance1.Id,teamID,SalesIQGlobalConstants.POSITION_UNIVERSE,'', '','');
         }catch(Exception e){
         }
         try{
             SalesIQDataTableWrapper wrap8 = SalesIQDataTableCtrl.getData('','Position__c', '',pos.Id,team_instance1.Id,teamID,SalesIQGlobalConstants.POSITION_UNIVERSE,'', '','');
         }catch(Exception e){}
         
         try{
             SalesIQDataTableWrapper wrap3 = SalesIQDataTableCtrl.getNextData('Position__c',1,wrap.queryString,wrap.columnsList,wrap.dataTypesList,pos.Id,team_instance1.Id,SalesIQGlobalConstants.POSITION_UNIVERSE,'','');
         }catch(Exception e){}
         
         try{
             SalesIQDataTableWrapper wrap4 = SalesIQDataTableCtrl.getSortData('Position__c','Name','ASC',wrap.queryString,wrap.columnsList,wrap.dataTypesList,pos.Id,team_instance1.Id,SalesIQGlobalConstants.POSITION_UNIVERSE,'','');
         }catch(Exception e){}
         
         try{
             SalesIQDataTableWrapper wrap5 = SalesIQDataTableCtrl.getSearchData('Position__c','',wrap.queryString,'',wrap.columnsList,wrap.dataTypesList,pos.Id,team_instance1.Id,SalesIQGlobalConstants.POSITION_UNIVERSE,'','');
         }catch(Exception e){}
         
         try{
             SalesIQDataTableWrapper wrap6 = SalesIQDataTableCtrl.getExport('Position__c',wrap.queryString,wrap.columnsList,wrap.dataTypesList,SalesIQGlobalConstants.UNASSIGNED_TERRITORY_CODE);
         }catch(Exception e){}
         
         
         
         List<String> disabledCheckbox = SalesIQDataTableCtrl.getDisabledCheckboxList('Position__c','inactive__c = true');
         test.stopTest();
        
         }
        
                
        
     }

     static testMethod void testPositionDataTableActionsOff()
     {
        Employee__c emp = CallPlanTestDataFactory.createEmployee();
         insert emp;
       
         Team__c team = TestDataFactory.createTeam('Base');
         insert team;

         Team__c team2 = TestDataFactory.createTeam('Overlay');
         team2.Controlling_Team__c = team.Id;
         insert team2;

         Team_Instance__c team_instance1 = TestDataFactory.CreateTeamInstance(team.Id,'Zip','',Date.today()-100,Date.today()+100);
         insert team_instance1;

         Team_Instance__c team_instance = TestDataFactory.CreateTeamInstance(team2.Id,'Zip','',Date.today()-100,Date.today()+100);
         insert team_instance;

         Position__C pos = CallPlanTestDataFactory.createPosition(null,team);
         pos.Hierarchy_Level__c = '2';
         pos.Team_Instance__c = team_instance1.Id;
         pos.Position_Type__c = 'District';
         insert pos;
         
         Position__C pos2 = CallPlanTestDataFactory.createPosition(null,team);
         pos2.Hierarchy_Level__c = '2';
         pos2.Team_Instance__c = team_instance1.Id;
         pos2.Position_Type__c = 'District';
         pos2.inactive__c = true;
         insert pos2;
         
         Position__C pos1 = CallPlanTestDataFactory.createPosition(pos,team);
         pos1.Team_Instance__c = team_instance1.Id;
         pos1.Position_Type__c = 'Territory';
         pos1.Hierarchy_Level__c = '1';
         insert pos1;

         System.debug('pos1 - '+pos1);
         
         Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
         insert org;
         Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
         insert country;
         
         Workspace__c workspace1 = new Workspace__c();
         workspace1.Name = 'test1';
         workspace1.Workspace_Description__c = 'Description';
         workspace1.Workspace_Start_Date__c = date.today();
         workspace1.Workspace_End_Date__c = date.today() + 5;
         workspace1.Country__c = country.id;
         insert workspace1;
         
         
         Scenario__c s = new Scenario__c();
         s.Workspace__c = workspace1.Id;
         s.Scenario_Type__c = SalesIQGlobalConstants.SCENARIO_TYPE_ALIGNMENT;
         insert s;

         Position__C posoverlay = CallPlanTestDataFactory.createPosition(pos,team2);
         insert posoverlay;         
         Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
         User usr = TestDataFactory.createUser(p.Id);
         insert usr;
         System.runAs(usr)
         { 
            List<PermissionSet> ps = [SELECT Id, Name From PermissionSet];
        
            TestDataFactory.assignPermissionSet(usr.Id, 'SalesIQ_HO');
        
             TriggerContol__c tc = new TriggerContol__c();
             tc.Name = 'SecurityUtil';
             tc.IsStopTrigger__c = true ;
             insert tc;
    
             TriggerContol__c tc1 = new TriggerContol__c();
             tc1.Name = 'ScenarioTrigger';
             tc1.IsStopTrigger__c = true ;
             insert tc1;
        

             TestDataFactory.createUserAccessPermissionFuture(pos.Id,usr.Id,team_instance.Id,'SalesIQ_HO');
             /*PermissionSet ps = [SELECT Name From PermissionSet WHERE Name = 'SalesIQ_HO'];
             insert new PermissionSetAssignment(AssigneeId = usr.Id, PermissionSetId = ps.Id );*/
             User_Access_Permission__c objUserAccessPerm = TestDataFactory.createUserAccessPerm(pos.Id,usr.Id,team_instance.Id);
             insert objUserAccessPerm;
             User_Access_Permission__c objUserAccessPerm2 = TestDataFactory.createUserAccessPerm(pos1.Id,usr.Id,team_instance1.Id);
             insert objUserAccessPerm2;
    
             Interface_Style_Config__c interfacestyle = new Interface_Style_Config__c();
            interfacestyle.IsEnabled__c = true;
            interfacestyle.Name = 'abc';
            interfacestyle.Field_Name__c = 'Position_Type__c';
            interfacestyle.Field_Value__c = 'District';
            interfacestyle.Interface_Name__c = 'Position__c';
            
            insert interfacestyle;
    
            ReadOnlyApplication__c readOnly  = new ReadOnlyApplication__c();
            readOnly.RosterDeletePosition__c = false; 
            readOnly.RosterEditPosition__c = false;
            readOnly.RosterHierarchyChange__c = false;
            readOnly.RosterPositionAccess__c = false;
            readOnly.Roster_Position_Attributes__c  = false;
            insert readOnly;
            
            /*ReadOnlyApplication__c readOnly2  = new ReadOnlyApplication__c();
             readOnly2.Name = 'HO';
            readOnly2.RosterDeletePosition__c = true; 
            readOnly2.RosterEditPosition__c = true;
            readOnly2.RosterHierarchyChange__c = true;
            readOnly2.RosterPositionAccess__c = true;
            readOnly2.Roster_Position_Attributes__c  = true;
            insert readOnly2;*/
            
             
            CR_Team_Instance_Config__c crTeamInstConf = new CR_Team_Instance_Config__c();
            crTeamInstConf.Configuration_Value__c = 'Territory';
            crTeamInstConf.Configuration_Type__c = 'Hierarchy Configuration';
            crTeamInstConf.Configuration_Name__c = '1';
            crTeamInstConf.Create__c = true;
            crTeamInstConf.Delete__c = true;
            crTeamInstConf.Edit__c = true;
            crTeamInstConf.Hierarchy_Change__c = true;
            crTeamInstConf.team_instance__c = team_instance1.id;
            
            CR_Team_Instance_Config__c crTeamInstConfDistrict = new CR_Team_Instance_Config__c();
            crTeamInstConfDistrict.Configuration_Value__c = 'District';
            crTeamInstConfDistrict.Configuration_Type__c = 'Hierarchy Configuration';
            crTeamInstConfDistrict.Configuration_Name__c = '2';
            crTeamInstConfDistrict.Create__c = true;
            crTeamInstConfDistrict.Delete__c = true;
            crTeamInstConfDistrict.Edit__c = true;
            crTeamInstConfDistrict.Hierarchy_Change__c = true;
            crTeamInstConfDistrict.team_instance__c = team_instance1.id;
           
            insert new CR_Team_Instance_Config__c[]{crTeamInstConf, crTeamInstConfDistrict} ;
    
            Team_Instance_Configuration__c teamInsConfTerr = new Team_Instance_Configuration__c();
            teamInsConfTerr.name = 'TerrConfig';
            teamInsConfTerr.Hierarchy_Level__c = '1';
            teamInsConfTerr.Pattern_Value__c = 'Terr{0000}';
            teamInsConfTerr.Position_Type__c = 'Territory';
            
            string teamID = team.id;
            if(teamId.length() > 15){
                teamID = teamID.left(15);
            }
            
            teamInsConfTerr.Team__c = teamID;
            teamInsConfTerr.Team_Instance__c = team_instance1.id;
            //insert teamInsConfTerr;
             
            Team_Instance_Configuration__c teamInsConfDistr = new Team_Instance_Configuration__c();
            //teamInsConf.Configuration_Type__c = 
            teamInsConfDistr.name = 'DistrictConfig';
            teamInsConfDistr.Hierarchy_Level__c = '2';
            teamInsConfDistr.Pattern_Value__c = 'Dist{0000}';
            teamInsConfDistr.Position_Type__c = 'District';
            teamInsConfDistr.Team__c = teamID;
            teamInsConfDistr.Team_Instance__c = team_instance1.id;
            //insert teamInsConfDistr;
    
            insert new Team_Instance_Configuration__c[]{teamInsConfTerr, teamInsConfDistr};
                
            
            test.startTest();
             
            SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
            generator.s = 'true';
            generator.objectName = 'Position__c';
            Test.setMock(HttpCalloutMock.class, generator);
             
            map<String,list<String>> profileMap = SalesIQDataTableCtrl.getProfileNameMap();
            try{
                SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Position__c', '',pos.Id,team_instance1.Id,teamID,SalesIQGlobalConstants.POSITION_UNIVERSE,'', JSON.serialize(profileMap),'');
            }catch(Exception e){
            }
            
            try{
                SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',pos2);
            }catch(Exception e){}
            try{
                SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',pos);
            }catch(Exception e){}
            try{
                SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',country);
            }catch(Exception e){}
             try{
                SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',Workspace1);
            }catch(Exception e){}
             try{
                SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',s);
            }catch(Exception e){}
            
            s.Scenario_Type__c = SalesIQGlobalConstants.SCENARIO_TYPE_CALL_PLAN;
            update s;
            SalesIQDataTableCtrl.setActionsAttributes(team_instance1,crTeamInstConf,readOnly,'District','Position Universe',s);
            test.stopTest();
            
         }
     }


    static testMethod void testPositionUniverseActions(){

        Team__c baseTeam = new Team__c(Name='HTN',Type__c='Base',Effective_start_Date__c = Date.newInstance(2015, 1, 1), Effective_End_Date__c = Date.newInstance(2018, 12, 31));
        insert baseTeam;

        Team_Instance__c baseTeamInstance =  new Team_Instance__c();
        BaseTeamInstance.Name = 'HTN_Q1_2016';
        BaseTeamInstance.Alignment_Period__c = 'Current';
        BaseTeamInstance.Team__c = baseTeam.id;
        BaseTeamInstance.IC_EffstartDate__c = Date.newInstance(2015, 1, 1);
        BaseTeamInstance.IC_EffendDate__c = Date.newInstance(2022, 12, 31);
        BaseTeamInstance.Alignment_Type__c = 'ZIP';
        BaseTeamInstance.isActiveCycle__c = 'Y'; 
        insert baseTeamInstance;

        Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
        User user = TestDataFactory.createUser(p.Id);
        insert user;

        Position__c nation = new Position__c();
        nation.name = 'USA';
        nation.Client_Territory_Name__c = 'North east';
        nation.Client_Position_Code__c = 'Dist0001';
        nation.Client_Territory_Code__c='1NE30000';
        nation.Position_Type__c='Nation';
        nation.inactive__c = false;
        nation.RGB__c = '41,210,117';
        nation.Team_Instance__c = baseTeamInstance.Id;
        nation.Team_iD__c = baseTeam.id;
        nation.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        nation.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        nation.Hierarchy_Level__c = '4';
        insert nation;

        Position__c regionPos =  new Position__c();
        regionPos.Name = 'region';
        regionPos.Client_Territory_Name__c = 'North east';
        regionPos.Client_Position_Code__c = 'Terr0001';
        regionPos.Client_Territory_Code__c='1NE30000';
        regionPos.Position_Type__c='Region';
        regionPos.inactive__c = false;
        regionPos.RGB__c = '41,210,117';
        regionPos.Team_Instance__c = baseTeamInstance.id;
        regionPos.Team_iD__c = baseTeam.id;
        regionPos.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        regionPos.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        regionPos.Hierarchy_Level__c = '3';
        regionPos.Parent_Position__c = nation.Id;
        insert regionPos;

        Position__c districtPos = new Position__c();
        districtPos.name = 'Newyork';
        districtPos.Client_Territory_Name__c = 'Newyork';
        districtPos.Client_Position_Code__c = 'Dist0002';
        districtPos.Client_Territory_Code__c='1NE30001';
        districtPos.Position_Type__c='District';
        districtPos.inactive__c = false;
        districtPos.RGB__c = '41,210,117';
        districtPos.Team_iD__c = baseTeam.id;
        districtPos.Team_Instance__c = baseTeamInstance.id;
        districtPos.Parent_Position__c = regionPos.Id;
        districtPos.Effective_Start_Date__c = Date.newInstance(2015, 1, 1);
        districtPos.Effective_End_Date__c = Date.newInstance(2018, 12, 31);
        districtPos.Hierarchy_Level__c = '2';
        districtPos.Related_Position_Type__c = 'Base';
        insert districtPos;

        
        Position__c terrPos = CallPlanTestDataFactory.createPosition(districtPos, baseTeam);
        terrPos.Name = 'abc';
        terrPos.Hierarchy_Level__c = '1';
        terrPos.Client_Position_Code__c = 'POS-0009';
        terrPos.inactive__c = false;
        terrPos.Effective_Start_Date__c = System.today();
        terrPos.Effective_End_Date__c = Date.newInstance(2018, 01, 01);
        terrPos.Related_Position_Type__c = 'Base';
        terrPos.Team_Instance__c = baseTeamInstance.Id;
        insert terrPos;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(terrPos, districtPos, BaseTeamInstance);
        territoryTeamInstance.X_Max__c=-72.6966429900;
        territoryTeamInstance.X_Min__c=-73.9625820000;
        territoryTeamInstance.Y_Max__c=40.9666490000;
        territoryTeamInstance.Y_Min__c=40.5821279800;
        territoryTeamInstance.Parent_Position_ID__c = districtPos.id;
        insert territoryTeamInstance;

        Change_Request_Type__c newPositionReqType2new =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.Update_POSITION);
        insert newPositionReqType2new;


        Change_Request__c changeRequest = new Change_Request__c();        
        changeRequest.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_PENDING;
        changeRequest.Destination_Position__c = terrPos.id;
        changeRequest.Destination_Positions__c=  baseTeamInstance.id;
        changeRequest.Source_Positions__c=  baseTeamInstance.id;
        changeRequest.Source_Position__c = terrPos.id;
        changeRequest.Team_Instance_ID__c =  baseTeamInstance.id;
        changeRequest.Change_Effective_Date__c = date.today();
        changeRequest.RecordTypeID__c= newPositionReqType2new.id;
        changeRequest.Request_Type_Change__c = SalesIQGlobalConstants.Update_POSITION;
        changeRequest.AllZips__c = '11099,12388,13077,19977';
        insert changeRequest;   

        Team__c overlayTeam = new Team__c(Name='HTN Overlay',Type__c='Overlay',Effective_start_Date__c = Date.newInstance(2015, 1, 1), Effective_End_Date__c = Date.newInstance(2018, 12, 31), Controlling_Team__c= baseTeam.id);
        overlayTeam.Is_Enforced__c = true;
        insert overlayTeam;

        Team_Instance__c overlayTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(overlayTeam, 'Zip');
        overlayTeamInstance.Name = 'HTN_Overlay_2016';
        overlayTeamInstance.Alignment_Period__c= 'Current';
        overlayTeamInstance.Base_Team_Instance__c = baseTeamInstance.Id;
        overlayTeamInstance.IC_EffstartDate__c = Date.newInstance(2015, 01, 01);
        overlayTeamInstance.IC_EffEndDate__c = Date.newInstance(2025, 01, 01);
        overlayTeamInstance.isActiveCycle__c = 'Y'; 
        overlayTeamInstance.IsCascadeDeleteAssignments__c = true;
        insert overlayTeamInstance;  

        Position__c terrPosOverlay = CallPlanTestDataFactory.createPosition(districtPos, overlayTeam);
        terrPosOverlay.Name = 'overlayterritory';
        terrPosOverlay.Hierarchy_Level__c = '1';
        terrPosOverlay.Team_Instance__c = overlayTeamInstance.Id;
        terrPosOverlay.Effective_Start_Date__c = Date.newInstance(2014, 01, 01);
        terrPosOverlay.Effective_End_Date__c = Date.newInstance(2019, 01, 01);
        terrPosOverlay.inactive__c = false;
        terrPosOverlay.Related_Position_Type__c = 'Overlay';
        insert terrPosOverlay;

        Position_Team_Instance__c territoryTeamInstanceOverlay = CallPlanTestDataFactory.CreatePosTeamInstance(terrPosOverlay, districtPos, overlayTeamInstance);
        territoryTeamInstanceOverlay.X_Max__c=-72.6966429900;
        territoryTeamInstanceOverlay.X_Min__c=-73.9625820000;
        territoryTeamInstanceOverlay.Y_Max__c=40.9666490000;
        territoryTeamInstanceOverlay.Y_Min__c=40.5821279800;
        territoryTeamInstanceOverlay.Parent_Position_ID__c = districtPos.id;
        insert territoryTeamInstanceOverlay;

        Change_Request__c changeRequest1 = new Change_Request__c();        
        changeRequest1.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
        changeRequest1.Destination_Position__c = terrPosOverlay.id;
        changeRequest1.Destination_Positions__c=  overlayTeamInstance.id;
        changeRequest1.Source_Positions__c=  overlayTeamInstance.id;
        changeRequest1.Source_Position__c = terrPosOverlay.id;
        changeRequest1.Team_Instance_ID__c =  overlayTeamInstance.id;
        changeRequest1.Change_Effective_Date__c = date.today();
        changeRequest1.RecordTypeID__c= newPositionReqType2new.id;
        changeRequest1.Request_Type_Change__c = SalesIQGlobalConstants.Update_POSITION;
        changeRequest1.AllZips__c = '11099,12388,13077,19977';
        insert changeRequest1;  

        Related_Position__c relatedPos = new Related_Position__c(); 
        relatedPos.Related_Position_Team_Instance__c = territoryTeamInstanceOverlay.id;
        relatedPos.Base_Position_Team_Instance__c = territoryTeamInstance.id;
        relatedPos.Related_Position__c = terrPosOverlay.id;
        relatedPos.Base_Position__C = terrPos.id;
        relatedPos.Effective_Start_Date__c = System.today().addMonths(-1);
        relatedPos.Effective_End_Date__c = System.today().addMonths(1);
        relatedPos.isActive__c = true;

        insert relatedPos;

        SalesIQDataTableCtrl.validatePositionActions('Update Position Attributes',baseTeamInstance.Id,terrPos.Id);
        SalesIQDataTableCtrl.validatePositionActions('Edit Position Hierarchy',baseTeamInstance.Id,terrPos.Id);
        changeRequest.Status__c = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
        update changeRequest;
        SalesIQDataTableCtrl.validatePositionActions('Edit Position Hierarchy',overlayTeamInstance.Id,terrPosOverlay.Id);
        SalesIQDataTableCtrl.validatePositionActions('Delete Position',baseTeamInstance.Id,terrPos.Id);
        SalesIQDataTableCtrl.validatePositionActions('Edit Overlay Association',overlayTeamInstance.Id,terrPos.Id);

        changeRequest1.Status__c = '';
        changeRequest.Status__c = '';
        update changeRequest;
        update changeRequest1;
        SalesIQDataTableCtrl.validatePositionActions('Edit Position Hierarchy',baseTeamInstance.Id,terrPos.Id);

    }

    static testMethod void testCountryDataTable(){
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;
        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;
        
        Profile p = [SELECT Id FROM Profile WHERE Name='System Administrator'];
         User usr = TestDataFactory.createUser(p.Id);
         insert usr;
        
        SalesIQCalloutMockGenerator generator= new SalesIQCalloutMockGenerator();
        generator.s = 'true';
        generator.objectName = 'Country__c';
        Test.setMock(HttpCalloutMock.class, generator);

        User_Persistence__c userPersistance = new User_Persistence__c();
        userPersistance.Workspace_Country__c = country.id;
        userPersistance.Default_Country__c = null;
        userPersistance.User__c = usr.Id;
        insert userPersistance;
        try{
            SalesIQDataTableWrapper wrap = SalesIQDataTableCtrl.getData('','Country__c', '','','','','Country',country.id, '','');
            SalesIQDataTableCtrl.setCountryForUser(country.id);
            SalesIQDataTableCtrl.checkCountryAccess(country.id);
        }catch(Exception e){
            
        }
        
        
        
        
        
    }

}